from collections.abc import Callable, Iterator
import random


type Supplier[T] = Callable[[], T]


def arbitrary_int(start: int, end: int) -> int:
    """ Returns an arbitrary integer between 'start' and 'end' (both inclusive).
        Raises ValueError if 'start' is greater than 'end' """
    return random.randint(start, end)


def arbitrary_char(start: str, end: str) -> str:
    """ Returns an arbitrary character between 'start' and 'end' (both inclusive).
        Raises ValueError if 'start' is greater than 'end' and TypeError if 
        both arguments are not chars. """
    ...


def arbitrary_bool() -> bool:
    """ Returns either True or False. """
    ...


def arbitrary_char_from(possible_chars: str) -> str:
    """ Returns an arbitrary character that occur in the given string.
        Raises ValueError if the given string is empty """
    ...


def arbitrary_uppercase_letter() -> str:
    """ Returns an arbitrary upper case ASCII letter ('A'-'Z'). """
    ...


def arbitrary_lowercase_letter() -> str:
    """ Returns an arbitrary lower case ASCII letter ('a'-'z'). """
    ...


def arbitrary_digit() -> str:
    """ Returns an arbitrary decimal digit ('0'-'9'). """
    ...


def arbitrary_str(arbitrary_size: Supplier[int], arbitrary_char: Supplier[str]) -> str:
    """ Returns a string of arbitrary size containing arbitrary chars. """
    ...


def arbitrary_from[T](values: list[T]) -> T:
    """ Returns an arbitrary value taken from the given list.
        Raises ValueError if the given list is empty. """
    ...


def arbitrary_list[T](arbitrary_size: Supplier[int], arbitrary_item: Supplier[T]) -> list[T]:
    """ Returns a list of arbitrary size containing arbitrary items. """
    ...


def arbitrary_dict[K, V](arbitrary_size: Supplier[int], arbitrary_key: Supplier[K],
                         arbitrary_value: Supplier[V]) -> dict[K, V]:
    """ Returns a dict of arbitrary size mapping arbitrary keys to arbitrary values. """
    ...
